commit 9fa953c8dfc7ee57ffd33e0b4e8be782c3119666
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Sun Mar 26 20:15:05 2023 +0200

    predict: Don't emit -Wsuggest-attribute=cold warning for functions which already have that attribute [PR105685]
    
    In the following testcase, we predict baz to have cold
    entry regardless of the user supplied attribute (as it call
    unconditionally a cold function), but still issue
    a -Wsuggest-attribute=cold warning despite it having that attribute
    already.
    
    The following patch avoids that.
    
    2023-03-26  Jakub Jelinek  <jakub@redhat.com>
    
            PR ipa/105685
            * predict.c (compute_function_frequency): Don't call
            warn_function_cold if function already has cold attribute.
    
            * c-c++-common/cold-2.c: New test.
    
    (cherry picked from commit 7eca91d4781bb3df941f25c30b971dac66ba1b3d)

diff --git a/gcc/predict.c b/gcc/predict.c
index a7ae977c866..b28474a0977 100644
--- a/gcc/predict.c
+++ b/gcc/predict.c
@@ -3941,7 +3941,9 @@ compute_function_frequency (void)
     }
 
   node->frequency = NODE_FREQUENCY_UNLIKELY_EXECUTED;
-  warn_function_cold (current_function_decl);
+  if (lookup_attribute ("cold", DECL_ATTRIBUTES (current_function_decl))
+      == NULL)
+    warn_function_cold (current_function_decl);
   if (ENTRY_BLOCK_PTR_FOR_FN (cfun)->count.ipa() == profile_count::zero ())
     return;
   FOR_EACH_BB_FN (bb, cfun)
diff --git a/gcc/testsuite/c-c++-common/cold-2.c b/gcc/testsuite/c-c++-common/cold-2.c
new file mode 100644
index 00000000000..7f78496fb82
--- /dev/null
+++ b/gcc/testsuite/c-c++-common/cold-2.c
@@ -0,0 +1,19 @@
+/* PR ipa/105685 */
+/* { dg-do compile } */
+/* { dg-options "-O2 -Wsuggest-attribute=cold" } */
+
+extern void foo (char *, char const *, int);
+
+__attribute__((cold)) char *
+bar (int x)
+{
+  static char b[42];
+  foo (b, "foo", x);
+  return b;
+}
+
+__attribute__((cold)) char *
+baz (int x)		/* { dg-bogus "function might be candidate for attribute 'cold'" } */
+{
+  return bar (x);
+}

